package tasks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// AddCommentToTaskHandlerFunc turns a function with the right signature into a add comment to task handler
type AddCommentToTaskHandlerFunc func(AddCommentToTaskParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddCommentToTaskHandlerFunc) Handle(params AddCommentToTaskParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddCommentToTaskHandler interface for that can handle valid add comment to task params
type AddCommentToTaskHandler interface {
	Handle(AddCommentToTaskParams, interface{}) middleware.Responder
}

// NewAddCommentToTask creates a new http.Handler for the add comment to task operation
func NewAddCommentToTask(ctx *middleware.Context, handler AddCommentToTaskHandler) *AddCommentToTask {
	return &AddCommentToTask{Context: ctx, Handler: handler}
}

/*AddCommentToTask swagger:route POST /tasks/{id}/comments tasks addCommentToTask

Adds a comment to a task

The comment can contain ___github markdown___ syntax.
Fenced codeblocks etc are supported through pygments.


*/
type AddCommentToTask struct {
	Context *middleware.Context
	Handler AddCommentToTaskHandler
}

func (o *AddCommentToTask) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, _ := o.Context.RouteInfo(r)
	var Params = NewAddCommentToTaskParams()

	uprinc, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// AddCommentToTaskBody A comment to create
//
// These values can have github flavored markdown.
//
// swagger:model AddCommentToTaskBody
type AddCommentToTaskBody struct {

	// content
	// Required: true
	Content *string `json:"content"`

	// user Id
	// Required: true
	UserID *int64 `json:"userId"`
}
